"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const default_1 = require("./default");
// @ts-ignore
const ansiStyles1 = require("ansi-styles");
const ansiStyles = ansiStyles1;
const jelppConfig = Object.assign(Object.assign({}, default_1.default), { defaultLogLevel: process.env.KARHU_LOG_LEVEL || process.env.NODE_LOG_LEVEL || 'INFO', colors: Object.assign(Object.assign({}, default_1.default.colors), { NOTICE: ansiStyles.color.blueBright }), logLevels: updatedLogLevels(), outputMapper, outputFormat: (process.env.KARHU_JSON || (process.stdout && !process.stdout.isTTY)) && !process.env.KARHU_NO_JSON ? 'json' : 'text' });
exports.default = jelppConfig;
function updatedLogLevels() {
    const ll = [...default_1.default.logLevels];
    ll.splice(ll.indexOf('WARN'), 0, 'NOTICE');
    return ll;
}
function outputMapper(val) {
    return errorOutputMapper(requestPromiseOutputMapper(val));
}
function errorOutputMapper(val) {
    if (val instanceof Error && val.stack) {
        return `${val.message} ${val.stack}`;
    }
    return val;
}
function requestPromiseOutputMapper(val) {
    if (val instanceof Error && val.name === 'StatusCodeError') {
        const err = val;
        return `StatusCodeError: ${err.statusCode} ${val.message}\n\n${err.response && err.response.body}\n\n${err.stack}`;
    }
    return val;
}
