"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
// @ts-ignore
var ansiStyles1 = require("ansi-styles");
var ansiStyles = ansiStyles1;
var util_1 = require("../main/util");
var util_2 = require("util");
var default_output_impl_1 = require("../main/default-output-impl");
exports.logLevels = [
    'NONE',
    'DEBUG',
    'INFO',
    'WARN',
    'ERROR'
];
var colors = {
    DEBUG: ansiStyles.color.magentaBright,
    WARN: ansiStyles.color.yellowBright,
    ERROR: [ansiStyles.color.whiteBright, ansiStyles.bgColor.bgRedBright],
};
var defaultConfig = {
    logLevels: exports.logLevels,
    colors: colors,
    outputFormat: process.env.KARHU_JSON ? 'json' : 'text',
    formatters: {
        text: function (toLog, logLevel, context, config, colorStart, colorEnd, transport) {
            var correlationId = config.getCorrelationId && config.getCorrelationId();
            var correlationIdPart = correlationId ? " [correlation-id=" + correlationId + "]" : '';
            return "[" + (transport.formatNow || config.formatNow)(config) + "] " + colorStart + logLevel + " " + context + " " + toLog.map(function (val) { return util_1.karhuInspect(val); }).join(' ') + correlationIdPart + colorEnd;
        },
        json: function (toLog, logLevel, context, config, colorStart, colorEnd, transport) {
            var correlationId = config.getCorrelationId && config.getCorrelationId();
            var output = { timestamp: (transport.formatNow || config.formatNow)(config), context: context, logLevel: logLevel, details: toLog, correlationId: correlationId };
            try {
                return JSON.stringify(output);
            }
            catch (err) {
                var fixed = __assign(__assign({}, output), { details: util_2.inspect(output.details, { depth: 5, breakLength: Infinity }) });
                return JSON.stringify(fixed);
            }
        }
    },
    contextSpecificLogLevels: new Map(),
    defaultLogLevel: 'INFO',
    envVariablePrefix: 'KARHU',
    outputMapper: function (value) { return value; },
    transports: {
        console: default_output_impl_1.default
    },
    formatNow: function () { return new Date().toISOString(); }
};
exports.default = defaultConfig;
