"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var temporarilyDisabled = false;
function toggleForceCaptureDisabled(disabled) {
    temporarilyDisabled = disabled;
}
exports.toggleForceCaptureDisabled = toggleForceCaptureDisabled;
function enableStandardOutputCapture(karhu, stdoutLogLevel, stderrLogLevel) {
    var wrappers = [
        wrap(karhu, 'stdout', stdoutLogLevel),
        wrap(karhu, 'stderr', stderrLogLevel),
    ];
    return {
        abort: function () {
            for (var _i = 0, wrappers_1 = wrappers; _i < wrappers_1.length; _i++) {
                var wrapper = wrappers_1[_i];
                wrapper.abort();
            }
        }
    };
}
exports.enableStandardOutputCapture = enableStandardOutputCapture;
function wrap(karhu, stream, logLevel) {
    var original = process[stream].write;
    var streamAsAny = process[stream];
    streamAsAny.write = function (arg1, arg2, arg3) {
        var data = typeof arg1 === 'string' ? arg1 : arg1.toString('UTF-8');
        var callback = typeof arg2 === 'function' ? arg2 : arg3;
        if (temporarilyDisabled || data.length === 0) {
            return original.call(process[stream], arg1, arg2, arg3);
        }
        var logFunction = karhu[logLevel];
        logFunction(data.endsWith && data.endsWith('\n') ? data.substr(0, data.length - 1) : data);
        if (typeof callback === 'function') {
            callback();
        }
        return true;
    };
    return {
        abort: function () {
            process[stream].write = original;
        }
    };
}
